%Minimos cuadrados Recursivos
%Autor: Edison Alejandro Alvarez Pimiento

echo off;
datos=xlsread('datos');
orden=0;
%Ingreso del orden del sistema a estimar
Subtitulo={'Orden del sistema:'};
def={'2'};
norden=inputdlg(Subtitulo,'Orden del sistema',1,def);
orden=2*str2double(norden);


%Caso de acuerdo al orden del sistema
switch(orden/2)
    
case 1 %Para el caso de orden 1
Subtitulo={'Factor de olvido','a1','b1','Periodo de muestreo'};
def={'0.9','0','0','0.001'};
eaap=inputdlg(Subtitulo,'Valores iniciales',1,def);
lam=str2double(eaap(1));
a1_ini=str2double(eaap(2));
b1_ini=str2double(eaap(3));
muestreo=str2double(eaap(4));
estim=[a1_ini b1_ini]';
 

case 2 %Para el caso de orden 2
subtitulo={'Factor de olvido','a1','a2','b1','b2','Periodo de muestreo'};
def={'0.9','0','0','0','0','0.001'};
eaap=inputdlg(subtitulo,'Valores iniciales',1,def);
lam=str2double(eaap(1));
a1_ini=str2double(eaap(2));
a2_ini=str2double(eaap(3));
b1_ini=str2double(eaap(4));
b2_ini=str2double(eaap(5));
muestreo=str2double(eaap(6));
estim=[a1_ini a2_ini b1_ini b2_ini]';


case 3 %Para el caso de orden 3
Subtitulo={'Factor de olvido','a1','a2','a3','b1','b2','b3','Periodo de muestreo'};
def={'0.9','0','0','0','0','0','0','0.001'};
eaap=inputdlg(Subtitulo,'Valores iniciales',1,def);
lam=str2double(eaap(1));
a1_ini=str2double(eaap(2));
a2_ini=str2double(eaap(3));
a3_ini=str2double(eaap(4));
b1_ini=str2double(eaap(5));
b2_ini=str2double(eaap(6));
b3_ini=str2double(eaap(7));
muestreo=str2double(eaap(8));
estim=[a1_ini a2_ini a3_ini b1_ini b2_ini b3_ini]';


otherwise %En cualquier otro caso
msgbox('Orden no vlido para este programa','Advertencia','warn')
end


sal=datos(:,2);
ent=datos(:,1);

P_ini=998; 
    
%Algoritmo recursivo
evol=estim;
e=0;
em=e;
P=P_ini*eye(orden);

%Tamao del archivo
tam_matriz=size(datos);
tam=tam_matriz(1,1);
pr=waitbar(0,'Wait... please!!!');
Fi_sal=0;
Fi_ent=0;
for i=(orden):tam,
for r=1:(orden/2),
Fi_sal(r)=[-sal(i-r)];
Fi_ent(r)=[ent(i-r)];
end
Fi=[Fi_sal Fi_ent]';
K=(P*Fi)/(lam+(Fi)'*P*Fi);
P=(P-(P*Fi*(Fi)'*P)/(lam+(Fi)'*P*Fi))/lam;
e=sal(i)-(Fi)'*estim;
estim=estim+K*e;
em=[em,e];
evol=[evol,estim];
waitbar(i/tam,pr);
end
close(pr);


%Funcin de Transferencia en tiempo discreto de acuerdo al orden......
switch(orden/2)

case 1
disp('El sistema en tiempo discreto (orden 1) es el siguiente:');
Z=tf([estim(2)],[1 estim(1)],muestreo)

disp('El sistema en tiempo continuo (orden 1) es el siguiente:');
S=d2c(Z,'zoh')
    
tamdatos=[1:tam];figure;

a1=evol(1,:);subplot(211);plot(tamdatos,a1);ylabel('a1');
title('Evolucin de los parmetros del denominador');
xlabel('Nmero de iteraciones');
b1=evol(2,:);subplot(212);plot(tamdatos,b1);ylabel('b1');
title('Evolucin de los parmetros del numerador');
xlabel('Nmero de iteraciones');
figure;plot(tamdatos,em);ylabel('Error');xlabel('Nmero de Iteraciones');
title('Minimizacin del Error');


case 2
disp('El sistema en tiempo discreto (orden 2) es el siguiente:');
Z=tf([estim(3) estim(4)],[1 estim(1) estim(2)],muestreo)

disp('El sistema en tiempo continuo (orden 2) es el siguiente:');
S=d2c(Z,'zoh')


case 3
disp('El sistema en tiempo discreto (orden 3) es el siguiente:');
Z=tf([estim(4) estim(5) estim(6)],[1 estim(1) estim(2) estim(3)],muestreo)

disp('El sistema en tiempo continuo (orden 3) es el siguiente:');
S=d2c(Z,'zoh')

end


[sal_sim,t_sim]=lsim(Z,ent);
figure;
subplot(2,2,1);
plot(t_sim,sal);
title('Salida real (azul)');
xlabel('Tiempo [seg.]');
subplot(2,2,2);
plot(t_sim,sal_sim,'r');
title('Salida del sistema estimado (rojo)');
xlabel('Tiempo [seg.]');
subplot(2,2,3);
plot(t_sim,sal);
hold;
plot(t_sim,sal_sim,'r');
title('Comparacin entre la salida real (azul) y la salida del sistema encontrado (rojo)');
xlabel('Tiempo [seg.]');
subplot(2,2,4);
plot(t_sim,ent);
title('Entrada real ');
xlabel('Tiempo [seg.]');

echo on;
%Fin del Programa